let webhooks = {}
const colors = require('terminalcolors.js')
var XMLHttpRequest = require('xhr2');
 webhooks.Start = class {
     /**
     * Starts up the webhook process
     * @class Webhook
     * @param {URL} url Webhook URL
     */
    constructor(url){
        this.url = url;

    }
    /**
     * 
     * @param {String} username Username of the webhook
     * @param {String} text Text of the webhook
     * @param {URL} AvatarURL Avatar for the webhook
     * @return {String} Returns true if operation was successful, Halts and returns false if operation failed
     */
    Send(username,text,AvatarURL){
        AvatarURL = AvatarURL || ""
        if(!username){return console.log(color.red("Please provide a username for your webhook"))}
        if(!text){return console.log(color.red("Please provide text for your webhook"))}
        if(!this.url){return console.log(color.red("No webhook URL specified!"))}
        const request = new XMLHttpRequest();
        request.open("POST", this.url);
        request.setRequestHeader('Content-type', 'application/json');
        const params = {
            username: username,
            avatar_url: AvatarURL,
            content: text
        }
        try{
            request.send(JSON.stringify(params));
            return true
        } catch(e) {
           console.log(color.red("Operation failed. Error: "+e))
           return false
        }
    }
}
module.exports = webhooks;